/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.api;

import io.docs_dispatcher.client.ApiCallback;
import io.docs_dispatcher.client.ApiClient;
import io.docs_dispatcher.client.ApiException;
import io.docs_dispatcher.client.ApiResponse;
import io.docs_dispatcher.client.Configuration;
import io.docs_dispatcher.client.Pair;
import io.docs_dispatcher.client.ProgressRequestBody;
import io.docs_dispatcher.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.docs_dispatcher.client.model.CompositeRequest;
import java.io.File;
import io.docs_dispatcher.client.model.Service;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class EndUserApiApi {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public EndUserApiApi() {
        this(Configuration.getDefaultApiClient());
    }

    public EndUserApiApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for dispatchersDispatch
     * @param dispatcherService The service used to handle the request (required)
     * @param compositeRequest  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersDispatchCall(Service dispatcherService, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = compositeRequest;

        // create path and map variables
        String localVarPath = "/api/{dispatcherService}"
            .replace("{" + "dispatcherService" + "}", localVarApiClient.escapeString(dispatcherService.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain",
            "text/html",
            "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
            "application/vnd.openxmlformats-officedocument.presentationml.presentation",
            "image/svg+xml",
            "image/png",
            "image/jpeg",
            "application/pdf",
            "multipart/alternative"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dispatchersDispatchValidateBeforeCall(Service dispatcherService, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dispatcherService' is set
        if (dispatcherService == null) {
            throw new ApiException("Missing the required parameter 'dispatcherService' when calling dispatchersDispatch(Async)");
        }

        return dispatchersDispatchCall(dispatcherService, compositeRequest, _callback);

    }

    /**
     * Handle unique service request for file(s) merging or generation
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param compositeRequest  (optional)
     * @return File
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public File dispatchersDispatch(Service dispatcherService, CompositeRequest compositeRequest) throws ApiException {
        ApiResponse<File> localVarResp = dispatchersDispatchWithHttpInfo(dispatcherService, compositeRequest);
        return localVarResp.getData();
    }

    /**
     * Handle unique service request for file(s) merging or generation
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param compositeRequest  (optional)
     * @return ApiResponse&lt;File&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<File> dispatchersDispatchWithHttpInfo(Service dispatcherService, CompositeRequest compositeRequest) throws ApiException {
        okhttp3.Call localVarCall = dispatchersDispatchValidateBeforeCall(dispatcherService, compositeRequest, null);
        Type localVarReturnType = new TypeToken<File>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Handle unique service request for file(s) merging or generation (asynchronously)
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param compositeRequest  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersDispatchAsync(Service dispatcherService, CompositeRequest compositeRequest, final ApiCallback<File> _callback) throws ApiException {

        okhttp3.Call localVarCall = dispatchersDispatchValidateBeforeCall(dispatcherService, compositeRequest, _callback);
        Type localVarReturnType = new TypeToken<File>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dispatchersDispatchWithOneComposable
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> for ex: the data object is not correct or missing, one of the specified service does exist but is not usable like requested </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersDispatchWithOneComposableCall(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = compositeRequest;

        // create path and map variables
        String localVarPath = "/api/{dispatcherService}/{composableService1}"
            .replace("{" + "dispatcherService" + "}", localVarApiClient.escapeString(dispatcherService.toString()))
            .replace("{" + "composableService1" + "}", localVarApiClient.escapeString(composableService1.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain",
            "text/html",
            "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
            "application/vnd.openxmlformats-officedocument.presentationml.presentation",
            "image/svg+xml",
            "image/png",
            "image/jpeg",
            "application/pdf",
            "multipart/alternative"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dispatchersDispatchWithOneComposableValidateBeforeCall(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dispatcherService' is set
        if (dispatcherService == null) {
            throw new ApiException("Missing the required parameter 'dispatcherService' when calling dispatchersDispatchWithOneComposable(Async)");
        }

        // verify the required parameter 'composableService1' is set
        if (composableService1 == null) {
            throw new ApiException("Missing the required parameter 'composableService1' when calling dispatchersDispatchWithOneComposable(Async)");
        }

        return dispatchersDispatchWithOneComposableCall(dispatcherService, composableService1, compositeRequest, _callback);

    }

    /**
     * Handle multiple services composing calls
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @return File
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> for ex: the data object is not correct or missing, one of the specified service does exist but is not usable like requested </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public File dispatchersDispatchWithOneComposable(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest) throws ApiException {
        ApiResponse<File> localVarResp = dispatchersDispatchWithOneComposableWithHttpInfo(dispatcherService, composableService1, compositeRequest);
        return localVarResp.getData();
    }

    /**
     * Handle multiple services composing calls
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @return ApiResponse&lt;File&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> for ex: the data object is not correct or missing, one of the specified service does exist but is not usable like requested </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<File> dispatchersDispatchWithOneComposableWithHttpInfo(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest) throws ApiException {
        okhttp3.Call localVarCall = dispatchersDispatchWithOneComposableValidateBeforeCall(dispatcherService, composableService1, compositeRequest, null);
        Type localVarReturnType = new TypeToken<File>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Handle multiple services composing calls (asynchronously)
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> for ex: the data object is not correct or missing, one of the specified service does exist but is not usable like requested </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersDispatchWithOneComposableAsync(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest, final ApiCallback<File> _callback) throws ApiException {

        okhttp3.Call localVarCall = dispatchersDispatchWithOneComposableValidateBeforeCall(dispatcherService, composableService1, compositeRequest, _callback);
        Type localVarReturnType = new TypeToken<File>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dispatchersDispatchWithTwoComposable
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param composableService2 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> for ex: the data object is not correct or missing, one of the specified service does exist but is not usable like requested </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersDispatchWithTwoComposableCall(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = compositeRequest;

        // create path and map variables
        String localVarPath = "/api/{dispatcherService}/{composableService1}/{composableService2}"
            .replace("{" + "dispatcherService" + "}", localVarApiClient.escapeString(dispatcherService.toString()))
            .replace("{" + "composableService1" + "}", localVarApiClient.escapeString(composableService1.toString()))
            .replace("{" + "composableService2" + "}", localVarApiClient.escapeString(composableService2.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain",
            "text/html",
            "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
            "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
            "application/vnd.openxmlformats-officedocument.presentationml.presentation",
            "image/svg+xml",
            "image/png",
            "image/jpeg",
            "application/pdf",
            "multipart/alternative"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dispatchersDispatchWithTwoComposableValidateBeforeCall(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dispatcherService' is set
        if (dispatcherService == null) {
            throw new ApiException("Missing the required parameter 'dispatcherService' when calling dispatchersDispatchWithTwoComposable(Async)");
        }

        // verify the required parameter 'composableService1' is set
        if (composableService1 == null) {
            throw new ApiException("Missing the required parameter 'composableService1' when calling dispatchersDispatchWithTwoComposable(Async)");
        }

        // verify the required parameter 'composableService2' is set
        if (composableService2 == null) {
            throw new ApiException("Missing the required parameter 'composableService2' when calling dispatchersDispatchWithTwoComposable(Async)");
        }

        return dispatchersDispatchWithTwoComposableCall(dispatcherService, composableService1, composableService2, compositeRequest, _callback);

    }

    /**
     * Handle multiple services composing calls
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param composableService2 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @return File
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> for ex: the data object is not correct or missing, one of the specified service does exist but is not usable like requested </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public File dispatchersDispatchWithTwoComposable(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest) throws ApiException {
        ApiResponse<File> localVarResp = dispatchersDispatchWithTwoComposableWithHttpInfo(dispatcherService, composableService1, composableService2, compositeRequest);
        return localVarResp.getData();
    }

    /**
     * Handle multiple services composing calls
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param composableService2 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @return ApiResponse&lt;File&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> for ex: the data object is not correct or missing, one of the specified service does exist but is not usable like requested </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<File> dispatchersDispatchWithTwoComposableWithHttpInfo(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest) throws ApiException {
        okhttp3.Call localVarCall = dispatchersDispatchWithTwoComposableValidateBeforeCall(dispatcherService, composableService1, composableService2, compositeRequest, null);
        Type localVarReturnType = new TypeToken<File>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Handle multiple services composing calls (asynchronously)
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param composableService2 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> A distant service response, for ex: Template name unknown, client configuration not found... </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> Distant service throws unexpected error </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> for ex: the data object is not correct or missing, one of the specified service does exist but is not usable like requested </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Successful generation. The result file returned as inline attachment </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersDispatchWithTwoComposableAsync(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest, final ApiCallback<File> _callback) throws ApiException {

        okhttp3.Call localVarCall = dispatchersDispatchWithTwoComposableValidateBeforeCall(dispatcherService, composableService1, composableService2, compositeRequest, _callback);
        Type localVarReturnType = new TypeToken<File>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for dispatchersValidateRequest
     * @param dispatcherService The service used to handle the request (required)
     * @param compositeRequest  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersValidateRequestCall(Service dispatcherService, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = compositeRequest;

        // create path and map variables
        String localVarPath = "/api/{dispatcherService}/validate"
            .replace("{" + "dispatcherService" + "}", localVarApiClient.escapeString(dispatcherService.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dispatchersValidateRequestValidateBeforeCall(Service dispatcherService, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dispatcherService' is set
        if (dispatcherService == null) {
            throw new ApiException("Missing the required parameter 'dispatcherService' when calling dispatchersValidateRequest(Async)");
        }

        return dispatchersValidateRequestCall(dispatcherService, compositeRequest, _callback);

    }

    /**
     * Validate (JSON) request for the given service
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param compositeRequest  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public void dispatchersValidateRequest(Service dispatcherService, CompositeRequest compositeRequest) throws ApiException {
        dispatchersValidateRequestWithHttpInfo(dispatcherService, compositeRequest);
    }

    /**
     * Validate (JSON) request for the given service
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param compositeRequest  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> dispatchersValidateRequestWithHttpInfo(Service dispatcherService, CompositeRequest compositeRequest) throws ApiException {
        okhttp3.Call localVarCall = dispatchersValidateRequestValidateBeforeCall(dispatcherService, compositeRequest, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Validate (JSON) request for the given service (asynchronously)
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param compositeRequest  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersValidateRequestAsync(Service dispatcherService, CompositeRequest compositeRequest, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = dispatchersValidateRequestValidateBeforeCall(dispatcherService, compositeRequest, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for dispatchersValidateRequestWithOneComposableService
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersValidateRequestWithOneComposableServiceCall(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = compositeRequest;

        // create path and map variables
        String localVarPath = "/api/{dispatcherService}/{composableService1}/validate"
            .replace("{" + "dispatcherService" + "}", localVarApiClient.escapeString(dispatcherService.toString()))
            .replace("{" + "composableService1" + "}", localVarApiClient.escapeString(composableService1.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dispatchersValidateRequestWithOneComposableServiceValidateBeforeCall(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dispatcherService' is set
        if (dispatcherService == null) {
            throw new ApiException("Missing the required parameter 'dispatcherService' when calling dispatchersValidateRequestWithOneComposableService(Async)");
        }

        // verify the required parameter 'composableService1' is set
        if (composableService1 == null) {
            throw new ApiException("Missing the required parameter 'composableService1' when calling dispatchersValidateRequestWithOneComposableService(Async)");
        }

        return dispatchersValidateRequestWithOneComposableServiceCall(dispatcherService, composableService1, compositeRequest, _callback);

    }

    /**
     * Validate (JSON) request for the given service composition
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public void dispatchersValidateRequestWithOneComposableService(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest) throws ApiException {
        dispatchersValidateRequestWithOneComposableServiceWithHttpInfo(dispatcherService, composableService1, compositeRequest);
    }

    /**
     * Validate (JSON) request for the given service composition
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> dispatchersValidateRequestWithOneComposableServiceWithHttpInfo(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest) throws ApiException {
        okhttp3.Call localVarCall = dispatchersValidateRequestWithOneComposableServiceValidateBeforeCall(dispatcherService, composableService1, compositeRequest, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Validate (JSON) request for the given service composition (asynchronously)
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersValidateRequestWithOneComposableServiceAsync(Service dispatcherService, Service composableService1, CompositeRequest compositeRequest, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = dispatchersValidateRequestWithOneComposableServiceValidateBeforeCall(dispatcherService, composableService1, compositeRequest, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for dispatchersValidateRequestWithTwoComposableServices
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param composableService2 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersValidateRequestWithTwoComposableServicesCall(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = compositeRequest;

        // create path and map variables
        String localVarPath = "/api/{dispatcherService}/{composableService1}/{composableService2}/validate"
            .replace("{" + "dispatcherService" + "}", localVarApiClient.escapeString(dispatcherService.toString()))
            .replace("{" + "composableService1" + "}", localVarApiClient.escapeString(composableService1.toString()))
            .replace("{" + "composableService2" + "}", localVarApiClient.escapeString(composableService2.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/plain"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call dispatchersValidateRequestWithTwoComposableServicesValidateBeforeCall(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'dispatcherService' is set
        if (dispatcherService == null) {
            throw new ApiException("Missing the required parameter 'dispatcherService' when calling dispatchersValidateRequestWithTwoComposableServices(Async)");
        }

        // verify the required parameter 'composableService1' is set
        if (composableService1 == null) {
            throw new ApiException("Missing the required parameter 'composableService1' when calling dispatchersValidateRequestWithTwoComposableServices(Async)");
        }

        // verify the required parameter 'composableService2' is set
        if (composableService2 == null) {
            throw new ApiException("Missing the required parameter 'composableService2' when calling dispatchersValidateRequestWithTwoComposableServices(Async)");
        }

        return dispatchersValidateRequestWithTwoComposableServicesCall(dispatcherService, composableService1, composableService2, compositeRequest, _callback);

    }

    /**
     * Validate (JSON) request for the given service composition
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param composableService2 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public void dispatchersValidateRequestWithTwoComposableServices(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest) throws ApiException {
        dispatchersValidateRequestWithTwoComposableServicesWithHttpInfo(dispatcherService, composableService1, composableService2, compositeRequest);
    }

    /**
     * Validate (JSON) request for the given service composition
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param composableService2 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> dispatchersValidateRequestWithTwoComposableServicesWithHttpInfo(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest) throws ApiException {
        okhttp3.Call localVarCall = dispatchersValidateRequestWithTwoComposableServicesValidateBeforeCall(dispatcherService, composableService1, composableService2, compositeRequest, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Validate (JSON) request for the given service composition (asynchronously)
     * 
     * @param dispatcherService The service used to handle the request (required)
     * @param composableService1 A service that can be composed with result of the first one (required)
     * @param composableService2 A service that can be composed with result of the first one (required)
     * @param compositeRequest  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 400 </td><td> for ex if the data object is not correct or missing </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> Unauthorized call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 403 </td><td> Forbidden call to service (distant or this API) </td><td>  -  </td></tr>
        <tr><td> 415 </td><td> Accept header media type missing or wildcard given </td><td>  -  </td></tr>
        <tr><td> 417 </td><td> For the given service, additional parameters are required and not present </td><td>  -  </td></tr>
        <tr><td> 501 </td><td> Service or method requested is not yet implemented </td><td>  -  </td></tr>
        <tr><td> 200 </td><td> Request is valid </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call dispatchersValidateRequestWithTwoComposableServicesAsync(Service dispatcherService, Service composableService1, Service composableService2, CompositeRequest compositeRequest, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = dispatchersValidateRequestWithTwoComposableServicesValidateBeforeCall(dispatcherService, composableService1, composableService2, compositeRequest, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
}
